import { initContainer } from "../ContainerBase/index";
import HashContainerBase from './Base/index';
declare class HashMap<K, V> extends HashContainerBase<K> {
    private hashTable;
    constructor(container?: initContainer<[K, V]>, initBucketNum?: number, hashFunc?: (x: K) => number);
    private reAllocate;
    clear(): void;
    forEach(callback: (element: [K, V], index: number) => void): void;
    /**
     * @description Insert a new key-value pair to hash map or set value by key.
     * @param key The key you want to insert.
     * @param value The value you want to insert.
     * @example HashMap.setElement(1, 2); // insert a key-value pair [1, 2]
     */
    setElement(key: K, value: V): void;
    /**
     * @description Get the value of the element which has the specified key.
     * @param key The key you want to get.
     */
    getElementByKey(key: K): V | undefined;
    /**
     * @description Removes the element of the specified key.
     * @param key The key you want to remove.
     */
    eraseElementByKey(key: K): void;
    /**
     * @param key The key you want to find.
     * @return Boolean about if the specified element in the hash map.
     */
    find(key: K): boolean;
    [Symbol.iterator](): Generator<[K, V], void, unknown>;
}
export default HashMap;
