import { initContainer } from "../ContainerBase/index";
import HashContainerBase from './Base/index';
declare class HashSet<K> extends HashContainerBase<K> {
    private hashTable;
    constructor(container?: initContainer<K>, initBucketNum?: number, hashFunc?: (x: K) => number);
    /**
     * @description Growth the hash table.
     * @private
     */
    private reAllocate;
    clear(): void;
    forEach(callback: (element: K, index: number) => void): void;
    /**
     * @description Insert element to hash set.
     * @param element The element you want to insert.
     */
    insert(element: K): void;
    /**
     * @description Remove the elements of the specified value.
     * @param element The element you want to remove.
     */
    eraseElementByKey(element: K): void;
    /**
     * @param element The element you want to find.
     * @return Boolean about if the specified element in the hash set.
     */
    find(element: K): boolean;
    [Symbol.iterator](): Generator<K, void, unknown>;
}
export default HashSet;
